#ifndef _MatrixClass_
#define _MatrixClass_

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

#include "wector.h"

class Matrix 
{
public:
	union {
		float m[4][4];
		struct
		{
			Wector row0;
			Wector row1;
			Wector row2;
			Wector Position;
		};
	};
public:
	Matrix(){};
	void Identity();
	void printf();
	void Transpose();
	void Translate(const Vector &a);
	void Scale(const Vector &a);
	void ScaleRows(const Vector &a);
	void Location(const Vector &a);
	Matrix Invert();
	Matrix Invert2();

	void Set(const int i,const int j,const float f);
	Matrix operator+(const Matrix &a);
	Matrix operator-(const Matrix &a);
	Matrix operator*(const Matrix &a);
	Matrix operator*(const float f);
	Wector operator*(const Wector &a);
	Vector operator*(const Vector &a);
	Vector operator%(const Vector &a);
};
#endif